<template>
  <div>
    <div class="app-container" v-if="isList">
      <el-form :model="queryParams" ref="queryForm" size="mini" :inline="true">
        <el-row >
          <el-col :span="18">
            <el-form-item label="部门">
              <el-cascader
                v-model="treeValue"
                :options="deptTree"
                :props="{ checkStrictly: true }"
                ref="cascaderHandle"
                clearable
                @change="handleChange"
                placeholder=""
                >
              </el-cascader>
            </el-form-item>
            <el-form-item label="员工">
              <el-input
                v-model="queryParams.params.staffCodeOrName"
                clearable
                @keyup.enter.native="btnSearch"
              />
            </el-form-item>
            <el-form-item label="状态" prop="status">
              <el-select
                size="mini"
                v-model="queryParams.status"
                placeholder=""
                clearable
              >
                <el-option
                  v-for="dict in dict.type.ehr_pm_status"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
                ></el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="月份" prop="month">
              <el-date-picker type="month" value-format="yyyy-MM" v-model="queryParams.month">
              </el-date-picker>
            </el-form-item>
            <el-form-item label="评估人" prop="evaluatorName">
              <el-input
                v-model="queryParams.evaluatorName"
                clearable
                @keyup.enter.native="btnSearch"
              />
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item style="float:right">
              <el-button type="primary" icon="el-icon-search" size="mini" @click="btnSearch">搜索</el-button>
              <el-button icon="el-icon-refresh" size="mini" @click="btnResetQuery">重置</el-button>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <el-table size="mini" height="500px" v-loading="loading" :data="listData" @row-dblclick="btnDetails">
        <el-table-column label="绩效编号" align="center" prop="id" />
        <el-table-column label="员工姓名" align="center" prop="staffName" />
        <el-table-column show-overflow-tooltip label="评估周期" align="center" prop="name" />
        <el-table-column label="月度" align="center" prop="month" />
        <el-table-column label="自评分" align="center" prop="saMark" />
        <el-table-column label="上级评分" align="center" prop="ldMark" />
        <el-table-column label="综合得分" align="center" prop="mark" />
        <el-table-column label="等级" align="center" prop="grade" />
        <el-table-column label="绩效系数" align="center" prop="coefficient" />
        <el-table-column label="状态" align="center" prop="status" >
          <template slot-scope="scope">
            <dict-tag :options="dict.type.ehr_pm_status" :value="scope.row.status"/>
          </template>
        </el-table-column>
        <el-table-column label="操作" fixed="right" align="center" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-search"
              @click="btnDetails(scope.row)"
            >详情</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="paginationClass">
        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </div>
    </div>
    <detail v-model="isList" v-if="!isList" :pageStu="page" :rowId="rowId" :ids="ids" @refresh="refresh" />
  </div>
</template>

<script>
import detail from './detail.vue'
import { listPerformance} from "@/api/business/ehr/pm/performance";
import { listDept} from "@/api/business/ehr/ehr/dept";

export default {
  name: "assess",
  dicts: ['ehr_pm_status'],
  components: {detail},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 总条数
      total: 0,
      // 表格数据
      listData: [],
      // id集合
      ids: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        params:{
          dataPermission: 'Y',
          staffCodeOrName: null,
        },
        status: null,
        month: null,
        dept: null,
        evaluatorName: null
      },
      //页面显示
      isList: true,
      //页面状态
      page: '',
      //详情id
      rowId: '',
      //部门树
      deptTree: [],
      //value
      treeValue: [],
    };
  },
  async created() {
    this.queryParams.month = this.getNowFormatDate();
    this.getList();
    listDept().then(response => {
      let arr = response.rows;
      arr.forEach(function(element) {
        element.parent_id = element.superiorsDept;
        element.value = element.code;
        element.label = element.name;
      });
      console.log("arr",arr);
      this.deptTree = this.arrayToTree(arr,null);
      console.log("deptTree",this.deptTree);
    });
  },
  methods: {
    /** 查询绩效列表 */
    getList() {
      this.loading = true;
      this.queryParams.dept = this.treeValue[this.treeValue.length - 1];
      listPerformance(this.queryParams).then(response => {
        this.listData = response.rows;
        this.ids = response.rows.map(item => item.id);
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    async btnSearch() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    btnResetQuery() {
      this.resetForm("queryForm");
      this.treeValue = [];
      this.queryParams.params.staffCodeOrName = null;
      this.btnSearch();
    },
    /** 刷新 */
    refresh(){
      this.resetForm("queryForm");
      this.treeValue = [];
      this.getList();
    },
    /** 进入详情 */
    btnDetails(row){
      this.rowId = row.id;
      this.page = 'add';
      this.isList = false;
    },
    
    arrayToTree(data, pid) {
      let result = []
      this.getChildren(data, result, pid)
      return result
    },
    getChildren(data, result, pid) {
      for (const item of data) {
        if (item.parent_id === pid) {
          const newItem = { children: [], ...item }
          result.push(newItem)
          this.getChildren(data, newItem.children, item.code)
        }
      }
    },
    //
    handleChange(value){
      console.log("value",value);
      this.$refs.cascaderHandle.dropDownVisible = false;
    },
    //获取当前年月
    getNowFormatDate() {
      let date = new Date(),
      year = date.getFullYear(),
      month = date.getMonth() + 1,
      strDate = date.getDate()
      if (month < 10) month = `0${month}`
      if (strDate < 10) strDate = `0${strDate}`
      return `${year}-${month}`
    }
  }
};
</script>

<style lang="scss" scoped>
.btn_grooup {
  margin-bottom: 10px;
  display: flex;
  justify-content: flex-end;
}
.paginationClass {
  z-index: 500;
  position: fixed;
  bottom: 10px;
  right: 10px;
  width: 100%;
  line-height: var(--footer-height);
  color: #fff;
}
</style>
